with Iirs; use Iirs;

package Back_End is
   --  Current back end in use:
   --    Simulator: makes the tree usuable for the simulator.
   --       passes: sem, canon, annotate.
   type Back_End_Enum is (Simulator);

   --  Return the name of the library file for LIBRARY.
   --  The library file describe the contents of LIBRARY.
   function Library_To_File_Name (Library: Iir_Library_Declaration)
     return String;

   --  UNIT is a design unit from parse.
   --  According to the current back-end, do what is necessary.
   --
   --  If MAIN is true, then UNIT is a wanted to be analysed design unit, and
   --  dump/list options can applied.
   --  This avoid to dump/list units fetched (through a selected name or a
   --  use clause) indirectly by the main unit.
   procedure Finish_Compilation
     (Unit : Iir_Design_Unit; Main : Boolean := False);

   --  Finish compilation for internal units (currently, only std.standard).
   procedure Internal_Compilation;

   --  Disp info of node NODE during for a vhdl listing according to the
   --  current back-end.
   --  info are annotations.
   procedure Disp_Vhdl_Info (Node : Iir);

   --  Disp info of node NODE during for a tree listing according to the
   --  current back-end.
   --  info are annotations.
   procedure Disp_Tree_Info (Node : Iir);
end Back_End;

