with Types; use Types;
with Iirs; use Iirs;

package Canon is
   --  If true, a label will be added for statements which do not have a
   --  label.
   Canon_Add_Labels : Boolean := False;

   --  If true, operands of type array element of a concatenation operator
   --  are converted (by an aggregate) into array.
   Canon_Concatenation : Boolean := False;

   -- Do canonicalization:
   --  Transforms concurrent statements into sensitized process statements
   --   (all but component instanciation and block).
   --  This computes sensivity list.
   --
   --  Association list are completed:
   --  * Formal are added.
   --  * association are created for formal not associated (actual is open).
   --  * an association is created (for block header only).
   procedure Canonicalize (Unit: Iir_Design_Unit);

   --  Create a default configuration declaration for architecture ARCH.
   function Create_Default_Configuration_Declaration
     (Arch : Iir_Architecture_Declaration)
     return Iir_Design_Unit;
end Canon;
