with Grt;
with Grt.Files;
with Grt.Types;
with Grt.Processes;
with Grt.Hierarchy;
with Grt.Lib;
with Grt.Options;
with Grt.Signals;
with Grt.Vcd;
with Grt.Shadow_Ieee;
with Grt.Errors; use Grt.Errors;
with Grt.Stacks;
with Grt.Images;

procedure Run is
   procedure Ghdl_Elaborate;
   pragma Import (C, Ghdl_Elaborate, "__ghdl_ELABORATE");

   Stop : Boolean;
begin
   Grt.Options.Decode (Stop);

   if not Stop then
      Grt.Stacks.Stack_Init;

      Grt.Vcd.Vcd_Init;

      Grt.Processes.Init;

      Ghdl_Elaborate;

      Grt.Signals.Order_All_Signals;

      Grt.Processes.Start;

      if Expect_Failure then
         Expect_Failure := False;
         Error ("error expected, but none occured");
      end if;
   end if;
end Run;
